﻿define([
    "dojo",
    "dojo/_base/declare",
    "epi/shell/widget/dialog/Alert",
    "epi/dependency",
    "epi/routes",
    "epi/shell/command/_Command"
], function (dojo, declare, Alert, dependency, routes, _Command) {

    return declare([_Command], {
        store: null,
        contentQuery: null,
       // canExecute: true,
        iconClass: "epi-iconProject",
        label: "Send to Translation",
        category: "context",
        _execute: function () {
            
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("workspace.lionjobstore11");
            var selfCom = this;
            $(selfCom.lionElement).addClass("disable-job-gadget");
            store.put({
                Id: this.model.contentLink,
                Action: 'send'
            }).then(function (item) {
                if (item.error) {
                    var errorDialog = new Alert({
                        heading: "Project not sent",
                        description: "Something went wrong when sending the project due to: " + item.errorMessage
                    });
                    errorDialog.show();
                } else {
                    var dialog = new Alert({
                        heading: "Project sent",
                        description: "The project has been sent."
                    });
                    dialog.show();

                    
                }
                $(selfCom.lionElement).removeClass("disable-job-gadget");
                //selfCom.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
                //selfCom.contentQuery.set("queryName", "WorkspaceQuery");
                LionBridgeConnectorGadget.sortGadgetSe();
            }, function (err) {
                $(selfCom.lionElement).removeClass("disable-job-gadget");
                //selfCom.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
                //selfCom.contentQuery.set("queryName", "WorkspaceQuery");
                LionBridgeConnectorGadget.sortGadgetSe();
            });

        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated. Subclasses should override this method.
            // tags:
            //      protected
            var sendLink = this;
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("workspace.translationprojectstore");
            dojo.when(store.get(this.model.contentLink + "?" + Math.random() * 9999999999), function (item) {
                
                if (item.status == 0) {
                    sendLink.set("canExecute", true);
                } else {
                    sendLink.set("canExecute", false);
                }

                if (!item.isSending && item.status != 0) {
                    sendLink.set("canExecute", false);
                }
            });
        }
    });
})